RtsDefine(["rtsmvc"], function(){

	(function(ns) {

		// RtsDefine a media
		ns.Media = ns.Model.extend({
			url:'/connecte/media/:id',
			defAttr : {
				id : {
					validation : ['RtsRequired']
				},
				type : {
					validation : ['RtsRequired']
				},
				title : {
					validation : ['RtsRequired']
				},
				expired : {
					validation : ['RtsRequired']
				},
				duration : {
					validation : ['RtsRequired']
				},
				image : {}, // could be null
				broadcastDate : {
					validation : ['RtsRequired']
				},
				nbPlays : {}, // could be null
				channelName : {
					validation : ['RtsRequired']
				},
				mediaUrl : {
					validation : ['RtsRequired']
				},
				expirationDate : {
					validation : ['RtsRequired']
				},
				isCatchUp : {
					validation : ['RtsRequired']
				},
				preview:{}
			},
			idAttribute : "id",
			
			/**
			 * Returns true if current media is a catchup media.
			 */
			isCatchUp: function() {
				return this.get("isCatchUp") && null != this.get("expirationDate");
			},
			
			getCatchUpRemainingDays: function() {
				var now = new Date().getTime();
				return Math.floor((_.rtsISOtoTS(this.get("expirationDate")) - now)/(1000*60*60*24));
			}
		});

		// RtsDefine articles collections (media)
		ns.MediaCollection = ns.Collection.extend({
			model : ns.Media
		});

	})(rtsmvc);
});
