RtsDefine([ "rtsmvc" ], function() {

	(function(ns) {

		var _ready = false,
			_readyListeners = [],
			_uid = 0;

		// RtsDefine a member
		ns.Member = ns.Model.extend({


			url : '/dynamique/profil/:idMember',
			idAttribute :'idMember',
			defAttr : {
				logged : {
					validation : [ 'RtsRequired' ]
				},
				enabled   : {
					validation: ['RtsRequired']
				},
				username  : {},
				email     : {},
				cid       : {},
				nickname  : {},
				creation  : {},
				firstname : {},
				lastname  : {},
				surname   : {},
				thumbs    : {},
				idMember  : {},
				isAdmin   : {},
				isEmailActivated : {}
			},
			getDisplayedName : function(){
				//return this.get('nickname') == null ? this.get('firstname')+' '+this.get('lastname') : this.get('nickname');
               			if (!ns.anonymous) {
					return this.get('firstname')+' '+this.get('lastname');
				}
				else {
					return this.get('firstname');
				}
			},
			/**
			 * Gives a bit more
			 *
			 * @param Boolean skipEnabledCheck (defaults to false)
			 * @return Boolean
			 */
			isLogged: function(skipEnabledCheck) {
				return !!(this.get("logged") && (skipEnabledCheck || this.get("enabled")));
			},

		    isRtsInternal : function() {
			    return this.get("email").split('@')[1] == 'rts.ch';
			},

			/**
			 * Returns thumb URI for given dimention (one of large, medium, small)
			 *
			 * @param String dimention  A string representing image dimentions in the form : width + "x" + height
			 * @return String
			 */
			getThumbUri: function(dimension) {
				var thumbs = this.get("thumbs");
				if (thumbs !== undefined && thumbs[dimension]) {
					return "//" + ns.Util.domains.marts + thumbs[dimension];
				}
			},

			isAdmin: function() {
				return this.get("isAdmin");
			},

			onReady: function(cb) {
				if (_ready) {
					cb(this);
				} else {
					cb.uid = ++_uid;
					_readyListeners.push(cb);
				}
			},

			refresh : function() {
				this.loadById();
			},

			isReady: function() { return _ready; }
		}, {THUMB_LARGE: "large",
			THUMB_MEDIUM: "medium",
			THUMB_SMALL: "small",
			THUMB_MINI: "mini"});



		ns.SessionMember = ns.Model.extend({
			url : '/dynamique/session',
			idAttribute : 'sessionId',
			isLogged : function(){
				return this.get('logged');
			},
			defAttr : {
				sessionId:{},
				idMember : {
					onSet : function(val){

						var me = this;
						var mem = new ns.Member();
						this.setLocal("member",mem);

						var runCb = function(){

							me.setLocal('loaded', true);

							var cbl = me.__memebercb || (me.__memebercb = []);

							for(var i = 0; i < cbl.length; i ++){
								cbl[i].call(cbl[i].ctx, me.get("logged"), me.get("member"));
							}

							me.__memebercb = [];
						}

						if(this.get('logged')){

							mem.loadById(val, {success:function(){


								runCb();


							}, reload:true});

						} else {

							runCb();
						}

					}
				},
				member : {},
				logged : {},
				loaded : {
					'default' : function(){
						return false;
					}
				}
			},
			getMember : function(cb, context){

				context = context || this;


				if(!this.get("loaded")){
					var cbl = this.__memebercb || (this.__memebercb = []);
					cb.ctx = context;

					cbl.push(cb);
				} else {
					cb.call(context, this.get("logged"), this.get("member"));
				}
			}

		});

		ns.SessionMember = ns.Util.makeShareable(ns.SessionMember, function(inst) {
			inst.loadById();
		});

	})(rtsmvc);

});
